<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of dummy_recommender
 * PS: třída se nezabývá kontrolou dat - při chybě spadne celý program (což ale u experimentů tohoto druhu není žádná tragedie)
 * @author peska
 */
class dummy_recommender {
    //put your code here
    private $train_set;
    private $test_set;
    private $solution;
    private $object_attributes;
    
    private $average_rating;
    private $user_factors;
    private $object_factors;
    
    /**
     * Konstruktor třídy: nejprve se naučí model UP a následně provede predikci pro všechny páry uživatel-objekt z test-setu
     * @param type $input_train_set název souboru obsahujícího train set
     * @param type $input_test_set název souboru obsahujícího test set
     * @param type $output_solution název souboru kam se má uložit výsledné řešení
     * @param type $input_object_attributes název souboru obsahujícího atributy objektu
     */
    function __construct($input_train_set, $input_test_set, $output_solution, $input_object_attributes){
        $this->train_set = $input_train_set;
        $this->test_set = $input_test_set;
        $this->solution = $output_solution;
        $this->object_attributes = $input_object_attributes;
        
        $this->learn_user_model();
        $this->evaluate();       
        
    }
    
    /**
     * Tato dummy funkce pouze načte train_set (atributy objektu nepoužívá) a uloží si baseline predictors
     * Vaše řešení může navíc např. zpracovávat atributy objektů, nebo rozumněji definovat model preferencí
     */
    function learn_user_model(){
        $object_rating_sum = array();
        $object_rating_count = array();
        $user_rating_sum = array();
        $user_rating_count = array();
        $rating_sum_total = 0;
        $rating_count_total = 0;
        
        $handle = fopen($this->train_set, "r");
        while (($buffer = fgets($handle)) !== false) {
            //$row[0] = uid, $row[2] = oid, $row[3] = rating
            $row = explode(",", $buffer); 
            $user_rating_sum[intval($row[0])] += $row[3];
            $user_rating_count[intval($row[0])] ++;
            $object_rating_sum[intval($row[2])] += $row[3];
            $object_rating_count[intval($row[2])] ++;
            $rating_sum_total += $row[3];
            $rating_count_total++;
        }
        //zpracujeme ratingy do baseline predictors
        $this->average_rating = $rating_sum_total/$rating_count_total;
        
        foreach ($user_rating_count as $key => $rating_count) {
            if($rating_count > 0){
                $rating_sum = $user_rating_sum[$key];
                $this->user_factors[$key] = ($rating_sum/$rating_count) - $this->average_rating;                
            }            
        }
        foreach ($object_rating_count as $key => $rating_count) {
            if($rating_count > 0){
                $rating_sum = $object_rating_sum[$key];
                $this->object_factors[$key] = ($rating_sum/$rating_count) - $this->average_rating;                
            }            
        }
        echo "Train set processed. Total instances: ".$rating_count_total."\n";
    }
    /**
     * Metoda evaluate pro každý řádek z test_set spočítá sumu baseline prediktorů jako předopkládané hodnocení a to uloží do solution
     */
    function evaluate(){       
        $handle = fopen($this->test_set, "r");
        $output = fopen($this->solution, "w");
        $count = 0;
        while (($buffer = fgets($handle)) !== false) {
            $count ++;
            //$row[0] = uid, $row[1] = oid
            $row = explode(",", $buffer); 
            if(isset($this->user_factors[intval($row[0])])){
                $user_factor = $this->user_factors[intval($row[0])];
            }else{
                $user_factor = 0;
            }
            if(isset($this->object_factors[intval($row[2])])){
                $object_factor = $this->object_factors[intval($row[2])];
            }else{
                $object_factor = 0;
            }
            $rating = $this->average_rating + $user_factor + $object_factor;
            //$rating = mt_rand(0, 10);
            fwrite($output, "".intval($row[0]).",".$row[1].",".intval($row[2]).",".$rating."\n") ; 
        }
        echo "Test set processed. Total instances: ".$count."\n";
    }    
}

new dummy_recommender("trainNDBI021.csv", "testNDBI021.csv", "dummy_solutionNDBI021.csv", "");